#!/bin/sh
#this is for hacks needed to fix a package, that might not have been done elsewhere.
#called from /usr/local/petget/installpkg.sh
#package that has just been installed is passed in on commandline.
#120924 DejaVu font no good for non-Latin languages. 120925 add korean.
#130122 xsane: remove warning about running as root.
#130221 pemasu: google-chrome run as root. 130224 pemasu: limit cache size.
#130326 pass in $DLPKG_NAME as $2. font size fix for 96 dpi.
#130507 kompozer needs MOZILLA_FIVE_HOME fix.

INSTALLEDPKG="$1" #ex: vlc_2.0.3-0ubuntu0.12.04.1_i386, without .deb
INSTALLEDNAME="$2" #130326

case $INSTALLEDPKG in
 vlc_*)
  #120907 vlc in debian/ubuntu configured to not run as root (it is a pre-compile configure option to enable running as root).
  #this hack will fix it...
  #note, this code is also in FIXUPHACK in 'vlc' template.
  if [ -f /usr/bin/bbe ];then #bbe is a sed-like utility for binary files.
   if [ -f /usr/bin/vlc  ];then
    bbe -e 's/geteuid/getppid/' /usr/bin/vlc > /tmp/vlc-temp1
    mv -f /tmp/vlc-temp1 /usr/bin/vlc
    chmod 755 /usr/bin/vlc
   fi
  fi
 ;;
 exaile_*)
  if [ -f /usr/bin/bbe ];then #bbe is a sed-like utility for binary files.
   if [ -f /usr/lib/exaile/exaile.py  ];then
    bbe -e 's/geteuid/getppid/' /usr/lib/exaile/exaile.py > /tmp/vlc-temp1
    mv -f /tmp/vlc-temp1 /usr/lib/exaile/exaile.py
    chmod 755 /usr/lib/exaile/exaile.py
   fi
  fi
 ;; 
 qjackctl_*)
  if [ -f /usr/bin/qjackctl ];then 
   yaf-splash -bg lightgreen -fg black -placement top -timeout 8 -text "fixing qjackctl for puppy" &
   petget http://distro.ibiblio.org/puppylinux/pet_packages-bionic64/qjackctlfixed-0.5.5-x86_64.pet
  fi
 ;; 
 qsynth_*)
  if [ -f /usr/bin/qsynth ];then 
   yaf-splash -bg lightgreen -fg black -placement top -timeout 8 -text "fixing qsynth for puppy" &
   petget http://distro.ibiblio.org/puppylinux/pet_packages-bionic64/qsynthfix-0.5.4-x86_64.pet
  fi
 ;; 
 qsampler_*)
  if [ -f /usr/bin/qsampler ];then 
   yaf-splash -bg lightgreen -fg black -placement top -timeout 8 -text "fixing qsampler for puppy" &
   petget http://distro.ibiblio.org/puppylinux/pet_packages-bionic64/qsamplerfix-0.5.3-x86_64.pet
  fi
 ;; 
 openshot-qt_*)
  if [ -f /usr/bin/openshot-qt ];then 
   yaf-splash -bg lightgreen -fg black -placement top -timeout 8 -text "installing missing deps for openshot" &
   urxvt -e pkg -f repo bionic-multiverse get python3-sip python3-requests python3-pkgconfig
  fi
 ;; 
 kodi_*)
  if [ -f /usr/lib/kodi/kodi.bin ];then 
   cp -R /usr/local/quickpet/checks/repository.xbmc.org /usr/share/kodi/addons
  fi
 ;; 
 "0ad"*)
  if [ -f /usr/bin/bbe ];then #bbe is a sed-like utility for binary files.
   if [ -f /usr/games/pyrogenesis  ];then
    bbe -e 's/geteuid/getppid/' /usr/games/pyrogenesis > /tmp/vlc-temp1
    mv -f /tmp/vlc-temp1 /usr/games/pyrogenesis
    chmod 755 /usr/games/pyrogenesis
   fi
  fi
 ;;
 lxappearance_*)
  if [ -f /usr/bin/lxappearance ];then 
    cp /usr/local/quickpet/checks/lxappearance.desktop /usr/share/applications
    fixmenus
  fi
 ;;
 liblapack3_*)
  if [ -f /usr/lib/lapack/liblapack.so.3 ];then 
    ln -s /usr/lib/lapack/liblapack.so.3 /usr/lib/liblapack.so.3
  fi
 ;;
 libblas3_*)
  if [ -f /usr/lib/blas/libblas.so.3 ];then 
    ln -s /usr/lib/blas/libblas.so.3 /usr/lib/libblas.so.3
  fi  
 ;;
 kde-runtime_*)
  if [ -f /usr/bin/kde4 ];then 
    update-mime-database /usr/share/mime
  fi
 ;;
 kde-workspace-bin_*)
  if [ -f /usr/bin/startkde ];then 
    sed -i '19s/.*/alias qdbus=QT_SELECT=qt4 qdbus/' /usr/bin/startkde
  fi
 ;;
 xfce4_*)
  if [ -f /usr/bin/xfce4-session ];then
    cp -R /usr/local/quickpet/checks/xfce/etc /
    cp -R /usr/local/quickpet/checks/xfce/root /
    cp -r /usr/local/quickpet/checks/xfce/usr /
   if [ -f /usr/bin/thunar  ];then
    bbe -e 's/geteuid/getppid/' /usr/bin/thunar > /tmp/thunar1
    mv -f /tmp/thunar1 /usr/bin/thunar
    chmod 755 /usr/bin/thunar
   fi
    `xmessage -center -bg "#9EB911" -fg "#060649" " use menu>>>desktop>>>wmswitcher
 to swap window managers"` &
  fi
 ;;
 google-earth-pro-stable_*)
   if [ -f /usr/bin/google-earth-* ];then
   ln -s /lib/ld-linux-x86-64.so.2 /lib/ld-lsb-x86-64.so.3
   echo '[Desktop Entry]
Version=1.0
Name=Google Earth
GenericName=3D planet viewer
Comment=Explore, search and discover the planet
Exec=google-earth-pro
Terminal=false
MultipleArgs=false
Icon=/opt/google/earth/pro/product_logo_256.png
Type=Application
Categories=X-Internet-browser
MimeType=application/vnd.google-earth.kml+xml;application/vnd.google-earth.kmz;application/earthviewer;application/keyhole' > /usr/share/applications/google-earth.desktop
chmod 755 /initrd/pup_rw
fixmenus
   fi
 ;;  
 "skypeforlinux"*)
   if [ -f /usr/share/skypeforlinux/skypeforlinux ];then
   mv /usr/bin/skypeforlinux /usr/bin/skypeforlinux1
   cp /usr/local/quickpet/checks/skypeforlinux /usr/bin/
   fi
 ;;
  "iron"*)
   if [ -f /usr/share/iron/iron ];then
   mv /usr/share/iron/iron /usr/share/iron/iron1
   echo "#!/bin/sh" > /usr/share/iron/iron
   echo '/usr/share/iron/iron1 --user-data-dir=/root/.config/chrome --allow-outdated-plugins --audio-buffer-size=2048 "$@"
' >> /usr/share/iron/iron
   chmod 755 /usr/share/iron/iron
   ln -s /usr/share/iron/iron /usr/bin/iron
   fi
 ;;
  python-wxgtk2.8_*)
   if [ -f /usr/lib/python2.7/dist-packages/wx-2.8-gtk2-unicode/wxPython/_wx.py ];then
   ln -s /usr/lib/python2.7/dist-packages/wx-2.8-gtk2-unicode/wx /usr/lib/python2.7/dist-packages
   fi
 ;;
  libwxgtk2.8-dev_*)
   if [ -f /usr/lib/wx/config/gtk2-unicode-release-2.8 ];then
   ln -s /usr/lib/wx/config/gtk2-unicode-release-2.8 /usr/bin/wx-config
   fi
 ;;
  libwxgtk3.0-dev_*)
   if [ -f /usr/lib/wx/config/gtk2-unicode-3.0 ];then
   ln -s /usr/lib/wx/config/gtk2-unicode-3.0 /usr/bin/wx-config
   fi   
 ;;
 "wbar"*)
  if [ -f /usr/bin/wbar ];then
  echo 'i: /usr/share/pixmaps/wbar/dock.png
c: wbar --bpress --above-desk --pos bottom --offset 30 --isize 50 --idist 5 --nanim 4 --falfa 65
t: /usr/share/fonts/default/truetype/droid/DroidSansMono/10

i: /usr/share/pixmaps/wbar/wbar.png
c: wbar-config
t: Config

i: /opt/palemoon/browser/icons/mozicon128.png
c: palemoon
t: Web Browser

i: /usr/share/pixmaps/sylpheed.png
c: sylpheed
t: E-Mail

i: /usr/share/icons/hicolor/48x48/apps/vlc.png
c: vlc
t: Media player

i: /usr/share/icons/hicolor/48x48/apps/geany.png
c: geany
t: Geany

i: /usr/local/lib/X11/themes/Ardis/console48.png
c: urxvt
t: Terminal

i: /usr/local/lib/X11/themes/Ardis/folder48.png
c: rox
t: File Manager' > /root/.wbar
   fi
 ;;
 google-chrome-*) #130221 pemasu. 130224 pemasu: limit cache size...
 if [ -f /opt/google/chrome/google-chrome ];then
rm /opt/google/chrome/google-chrome.bin
mv /opt/google/chrome/google-chrome /opt/google/chrome/google-chrome.bin
   echo '#!/bin/sh
   APP='/opt/google/chrome/google-chrome.bin'
#script to run $APP as spot...
ARGS=""
[ "$1" ] && while [ "$1" ]; do ARGS="$ARGS \"$1\""; shift; done
if [ $(id -u) -eq 0 ]; then
 [ $XAUTHORITY ] && cp $XAUTHORITY /root/spot/.Xauthority 2>/dev/null
 touch /root/spot/.Xauthority
 #following line is mostly there to catch any root:root files that may have got copied in...
 find /root/spot \( -not -user spot -or -not -group spot \) -exec chown -h spot:spot {} \; &
 export XAUTHORITY=/root/spot/.Xauthority  
 export XDG_CONFIG_HOME=/root/spot/.config
 export XDG_CACHE_HOME=/root/spot/.cache
 export XDG_DATA_HOME=/root/spot/.local/share
 exec su spot -s /bin/sh -c "\"$APP\" $ARGS"
else #precaution
 exec "$APP" "$ARGS"
fi' > /opt/google/chrome/google-chrome 
chmod 755 /opt/google/chrome/google-chrome
   echo '[Desktop Entry]
Encoding=UTF-8
Version=1.0
Name=Google Chrome web browser
GenericName=Google Chrome
Comment=Google Chrome web browser
Exec=google-chrome-stable
Terminal=false
Type=Application
Icon=/opt/google/chrome/product_logo_128.png
Categories=WebBrowser;' > /usr/share/applications/google-chrome.desktop
chmod 755 /initrd/pup_rw
fixmenus
   fi
 ;;
vivaldi-*) 
   if [ -f /opt/vivaldi/vivaldi  ];then
rm /opt/vivaldi/vivaldi.launch
mv /opt/vivaldi/vivaldi /opt/vivaldi/vivaldi.launch
   echo '#!/bin/sh
   APP='/opt/vivaldi/vivaldi.launch'
#script to run $APP as spot...
ARGS=""
[ "$1" ] && while [ "$1" ]; do ARGS="$ARGS \"$1\""; shift; done
if [ $(id -u) -eq 0 ]; then
 [ $XAUTHORITY ] && cp $XAUTHORITY /root/spot/.Xauthority 2>/dev/null
 touch /root/spot/.Xauthority
 #following line is mostly there to catch any root:root files that may have got copied in...
 find /root/spot \( -not -user spot -or -not -group spot \) -exec chown -h spot:spot {} \; &
 export XAUTHORITY=/root/spot/.Xauthority  
 export XDG_CONFIG_HOME=/root/spot/.config
 export XDG_CACHE_HOME=/root/spot/.cache
 export XDG_DATA_HOME=/root/spot/.local/share
 exec su spot -s /bin/sh -c "\"$APP\" $ARGS"
else #precaution
 exec "$APP" "$ARGS"
fi' > /opt/vivaldi/vivaldi 
chmod 755 /opt/vivaldi/vivaldi
   echo '[Desktop Entry]
Encoding=UTF-8
Version=1.0
Name=vivaldi
GenericName=vivaldi
Comment=vivaldi web browser
Exec=vivaldi-stable
Terminal=false
Type=Application
Icon=/opt/vivaldi/product_logo_128.png
Categories=WebBrowser;' > /usr/share/applications/vivaldi-stable.desktop
chmod 755 /initrd/pup_rw
fixmenus
   fi
 ;;
chromium-browser_*)
   if [ -f /usr/lib/chromium-browser/chromium-browser ];then
   mv /usr/lib/chromium-browser/chromium-browser /usr/lib/chromium-browser/chromium-browser.bin
echo '#!/bin/sh
   APP='/usr/lib/chromium-browser/chromium-browser.bin'
#script to run $APP as spot...
ARGS=""
[ "$1" ] && while [ "$1" ]; do ARGS="$ARGS \"$1\""; shift; done
if [ $(id -u) -eq 0 ]; then
 [ $XAUTHORITY ] && cp $XAUTHORITY /root/spot/.Xauthority 2>/dev/null
 touch /root/spot/.Xauthority
 #following line is mostly there to catch any root:root files that may have got copied in...
 find /root/spot \( -not -user spot -or -not -group spot \) -exec chown -h spot:spot {} \; &
 export XAUTHORITY=/root/spot/.Xauthority  
 export XDG_CONFIG_HOME=/root/spot/.config
 export XDG_CACHE_HOME=/root/spot/.cache
 export XDG_DATA_HOME=/root/spot/.local/share
 exec su spot -s /bin/sh -c "\"$APP\" $ARGS"
else #precaution
 exec "$APP" "$ARGS"
fi' > /usr/lib/chromium-browser/chromium-browser
chmod 755 /usr/lib/chromium-browser/chromium-browser
chmod 755 /initrd/pup_rw
   yaf-splash -bg lightgreen -fg black -placement top -timeout 8 -text "installing missing deps" &
   urxvt -e pkg -f repo bionic-universe get chromium-codecs-ffmpeg
   fi
 ;;
opera-*) 
   if [ -f /usr/lib/opera/opera  ];then
rm /usr/lib/opera/opera.bin
mv /usr/lib/opera/opera /usr/lib/opera/opera.bin
   echo '#!/bin/sh
   APP='/usr/lib/opera/opera.bin'
#script to run $APP as spot...
ARGS=""
[ "$1" ] && while [ "$1" ]; do ARGS="$ARGS \"$1\""; shift; done
if [ $(id -u) -eq 0 ]; then
 [ $XAUTHORITY ] && cp $XAUTHORITY /root/spot/.Xauthority 2>/dev/null
 touch /root/spot/.Xauthority
 #following line is mostly there to catch any root:root files that may have got copied in...
 find /root/spot \( -not -user spot -or -not -group spot \) -exec chown -h spot:spot {} \; &
 export XAUTHORITY=/root/spot/.Xauthority  
 export XDG_CONFIG_HOME=/root/spot/.config
 export XDG_CACHE_HOME=/root/spot/.cache
 export XDG_DATA_HOME=/root/spot/.local/share
 exec su spot -s /bin/sh -c "\"$APP\" $ARGS"
else #precaution
 exec "$APP" "$ARGS"
fi' > /usr/lib/opera/opera
chmod 755 /usr/lib/opera/opera   
   echo '[Desktop Entry]
Encoding=UTF-8
Version=1.0
Name=Opera
GenericName=Opera
Comment=opera web browser
Exec=opera
Terminal=false
Type=Application
Icon=/usr/share/icons/hicolor/128x128/apps/opera.png
Categories=WebBrowser;' > /usr/share/applications/opera.desktop
chmod 755 /initrd/pup_rw
fixmenus
   fi
 ;;   
 jwm_theme_*)
  #120924 DejaVu font no good for non-Latin languages...
  #see also langpack_* pinstall.sh (template is in /usr/share/doc/langpack-template/pinstall.sh, read by momanager).
  LANGUSER="`grep '^LANG=' /etc/profile | cut -f 2 -d '=' | cut -f 1 -d ' '`"
  case $LANGUSER in
   zh*|ja*|ko*) #chinese, japanese, korean
    sed -i -e 's%DejaVu Sans%Sans%' /etc/xdg/templates/_root_*
    sed -i -e 's%DejaVu Sans%Sans%' /root/.jwm/themes/*-jwmrc
    sed -i -e 's%DejaVu Sans%Sans%' /root/.jwm/jwmrc-theme
   ;;
  esac
  #130326 font size fix for 96 dpi...
  if [ "$INSTALLEDNAME" ];then
   JWMTHEMEFILE="$(grep '^/root/\.jwm/themes/.*-jwmrc$' /root/.packages/${INSTALLEDNAME}.files | head -n 1)"
   [ "$JWMTHEMEFILE" ] && hackfontsize "JWMTHEMES='${JWMTHEMEFILE}'"
  fi
 ;;
 openbox*)
  #120924 DejaVu font no good for non-Latin languages...
  #see also langpack_* pinstall.sh (template is in /usr/share/doc/langpack-template/pinstall.sh, read by momanager).
  LANGUSER="`grep '^LANG=' /etc/profile | cut -f 2 -d '=' | cut -f 1 -d ' '`"
  case $LANGUSER in
   zh*|ja*|ko*) #chinese, japanese, korean
    sed -i -e 's%DejaVu Sans%Sans%' /etc/xdg/openbox/*.xml
    sed -i -e 's%DejaVu Sans%Sans%' /root/.config/openbox/*.xml
   ;;
  esac
 ;;
 gtk_theme_*)
  #120924 DejaVu font no good for non-Latin languages...
  #see also langpack_* pinstall.sh (template is in /usr/share/doc/langpack-template/pinstall.sh, read by momanager).
  LANGUSER="`grep '^LANG=' /etc/profile | cut -f 2 -d '=' | cut -f 1 -d ' '`"
  case $LANGUSER in
   zh*|ja*|ko*) #chinese, japanese, korean
    GTKRCFILE="$(find /usr/share/themes -type f -name gtkrc | tr '\n' ' ')"
    for ONEGTKRC in $GTKRCFILE
    do
     sed -i -e 's%DejaVu Sans%Sans%' $ONEGTKRC
    done
   ;;
  esac
  #130326 font size fix for 96 dpi...
  if [ "$INSTALLEDNAME" ];then
   GTKTHEMEFILE="$(grep '^/usr/share/themes/.*/gtk-2\.0/gtkrc$' /root/.packages/${INSTALLEDNAME}.files | head -n 1)"
   [ "$GTKTHEMEFILE" ] && hackfontsize "GTKRCS='${GTKTHEMEFILE}'"
  fi
 ;;
 seamonkey*|firefox*)
  #120924 DejaVu font no good for non-Latin languages...
  #see also langpack_* pinstall.sh (template is in /usr/share/doc/langpack-template/pinstall.sh, read by momanager).
  LANGUSER="`grep '^LANG=' /etc/profile | cut -f 2 -d '=' | cut -f 1 -d ' '`"
  case $LANGUSER in
   zh*|ja*|ko*) #chinese, japanese, korean
    MOZFILE="$(find /root/.mozilla -type f -name prefs.js -o -name '*.css' | tr '\n' ' ')"
    for ONEMOZ in $MOZFILE
    do
     sed -i -e 's%DejaVu Sans%Sans%' $ONEMOZ
    done
   ;;
  esac
 ;;
 mc_*) #121206 midnight commander
  #in ubuntu, won't run from the menu. this fixes it...
  [ -f /usr/share/applications/mc.desktop ] && sed -i -e 's%^Exec=.*%Exec=TERM=xterm mc%' /usr/share/applications/mc.desktop
 ;;
 xsane*) #130122
  #xsane puts up a warning msg at startup if running as root, remove it...
  #this code is also in file FIXUPHACK in xsane template (in Woof).
  #WARNING: this may only work for x86 binary.
  if [ -f /usr/bin/bbe ];then #bbe is a sed-like utility for binary files.
   if [ -f /usr/bin/xsane  ];then
    bbe -e 's/\x6b\x00getuid/\x6b\x00getpid/' /usr/bin/xsane > /tmp/xsane-temp1
    mv -f /tmp/xsane-temp1 /usr/bin/xsane
    chmod 755 /usr/bin/xsane
   fi
  fi
 ;;
 kompozer*) #130507
  [ -f /usr/bin/kompozer ] && [ -d /usr/lib/kompozer ] && sed -i -e 's%^moz_libdir=%export MOZILLA_FIVE_HOME="/usr/lib/kompozer" #BK\nmoz_libdir=%' /usr/bin/kompozer
 ;;
esac

